"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/** get diagonal repeat lines: looks something like
 *   /             \
    |.             .|
    |.  A m  Gm7   .|
     \             /
*/
var getRepeatLines = function getRepeatLines(dims, type) {
  //x and y determine the diagonal line's length
  var y = 5;
  var x = 7;
  var drawX = type === "backward" ? -x : x;
  var moveX = type === "backward" ? dims.xEnd : dims.x;
  return ["M" + moveX + " " + dims.y + " l " + drawX + " " + -y, "M" + moveX + " " + dims.yEnd + " l " + drawX + " " + y];
};

/* get the points in the repetition
 *  |:  A m7   |  Gm7  :|
 * */
var getRepetitionCircles = function getRepetitionCircles(bars, barView) {
  var yDistance = 4; // from y center of bar to point (either point above or below)
  var xDistance = 4; // distance from bar to points

  var getY = function getY(y, type) {
    var fDist = type === "up" ? -yDistance : yDistance;
    return y + barView.bar.height / 2 + fDist;
  };
  var circle = {
    r: 1,
    stroke: "black"
  };
  var getCircles = function getCircles(bar, barView) {
    var x = bar.repeat === "forward" ? bar.dimensions.x + xDistance : bar.dimensions.x + barView.bar.width - xDistance;
    var y1 = getY(bar.dimensions.y, "up");
    var y2 = getY(bar.dimensions.y, "down");
    var circle1 = _objectSpread(_objectSpread({}, circle), {
      cx: x,
      cy: y1
    });
    var circle2 = _objectSpread(_objectSpread({}, circle), {
      cx: x,
      cy: y2
    });
    return [circle1, circle2];
  };
  return bars.filter(function (bar) {
    return !!bar.repeat;
  }).flatMap(function (bar) {
    return getCircles(bar, barView);
  });
};
var getBarLines = function getBarLines(bars, barView) {
  if (!barView.bar || barView.bar.width === undefined || barView.bar.height === undefined || barView.bar.repetitionLineSpace === undefined) throw new TypeError("barView arguments needed: bar.width, bar.height and bar.repetitionLineSpace");
  var barLines = bars.flatMap(function (bar) {
    var dims = {
      x: bar.dimensions.x,
      y: bar.dimensions.y,
      xEnd: bar.dimensions.x + barView.bar.width,
      yEnd: bar.dimensions.y + barView.bar.height
    };
    var line = ["M" + dims.xEnd + " " + dims.y + " l 0 " + barView.bar.height];
    if (bar.endSection) line.push("m" + (dims.xEnd - barView.bar.repetitionLineSpace) + " " + dims.y + " l 0 " + barView.bar.height);
    if (bar.repeat) {
      if (bar.repeat === "forward") {
        line.push("m" + dims.x + " " + dims.y + " l 0 " + barView.bar.height);
      }
      line = line.concat(getRepeatLines(dims, bar.repeat));
    }
    return line;
  });
  return {
    paths: barLines,
    circles: getRepetitionCircles(bars, barView)
  };
};
var _default = exports["default"] = getBarLines;