"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ChordTexts = function ChordTexts() {
  var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
  var defaultSizeChord = 30 * scale;
  var defaultSizeBass = 25 * scale;
  var defaultSizeSup = 25 * scale;
  var strokeWidth = 3 * scale;
  var getAttr = function getAttr(fontSize) {
    return {
      fill: "#000",
      fontSize: fontSize,
      fontFamily: "jazz-font,Verdana,Courier",
      textAnchor: "start"
    };
  };
  // repeat chord sign: %
  var getRepeatSign = function getRepeatSign(x, y) {
    var MARGIN_REPEAT_SIGN = 10;
    var repeatSignX = x + MARGIN_REPEAT_SIGN;
    var repeatSignY = y + MARGIN_REPEAT_SIGN * scale;
    var repeatSignSize = 20 * scale;
    var circle = {
      r: 3 * scale,
      stroke: "black",
      fill: "black"
    };
    var circles = [_objectSpread(_objectSpread({}, circle), {
      cx: repeatSignX,
      cy: repeatSignY - repeatSignSize
    }), _objectSpread(_objectSpread({}, circle), {
      cx: repeatSignX + repeatSignSize,
      cy: repeatSignY
    })];
    var lines = [];
    lines.push({
      d: "M " + repeatSignX + " " + repeatSignY + " l " + repeatSignSize + " " + -1 * repeatSignSize,
      strokeWidth: strokeWidth,
      stroke: "black"
    });
    return {
      lines: lines,
      texts: [],
      circles: circles
    };
  };
  var getChordSvgElems = function getChordSvgElems(chord, x, y) {
    if (chord.same) return getRepeatSign(x, y);
    y += 5; //due to font, we have to put them 5 points higher
    var lines = [];
    var chordText = chord.pitch + chord.chordType;
    var texts = [_objectSpread({
      x: x,
      y: y,
      text: chordText
    }, getAttr(defaultSizeChord))];
    if (chord.sup) {
      texts.push(_objectSpread({
        x: x + scale * (chordText.length * 10 + 5),
        y: y - scale * (defaultSizeChord / 3),
        text: chord.sup
      }, getAttr(defaultSizeSup)));
    }
    if (chord.bass) {
      var bassX = x + scale * (chordText.length * 10);
      var bassY = y + scale * 25;
      texts.push(_objectSpread({
        x: bassX,
        y: bassY,
        text: chord.bass
      }, getAttr(defaultSizeBass)));
      lines.push({
        d: "M" + (bassX - scale * 10) + " " + (y + scale * 10) + " l " + scale * 24 + " " + scale * -15,
        strokeWidth: strokeWidth,
        stroke: "black"
      });
    }
    var returnObj = {
      texts: texts
    };
    if (lines.length) returnObj.lines = lines;
    return returnObj;
  };
  var getSvgElems = function getSvgElems(bars, barView) {
    var timeSignature = bars[0].timeSignature || "44";
    var barChordsText = bars.map(function (bar) {
      var startXList = barView.getStartXList(timeSignature, bar.chords.map(function (chord) {
        return chord.duration;
      }));
      var barChords = bar.chords.map(function (chord, i) {
        chord.startX = startXList[i];
        return chord;
      });
      var chordTexts = barChords.map(function (chord) {
        var x = bar.dimensions.x + chord.startX;
        var y = bar.dimensions.y + barView.bar.padding.top;
        return getChordSvgElems(chord, x, y);
      });
      var lines = chordTexts.filter(function (chord) {
        return !!chord.lines;
      }).flatMap(function (chord) {
        return chord.lines;
      });
      var circles = chordTexts.filter(function (chord) {
        return !!chord.circles;
      }).flatMap(function (chord) {
        return chord.circles;
      });
      chordTexts = chordTexts.flatMap(function (chord) {
        return chord.texts;
      });
      return {
        startXList: startXList,
        chordTexts: chordTexts,
        lines: lines,
        circles: circles
      };
    });
    var barCircles = barChordsText.filter(function (bar) {
      return !!bar.circles;
    }).flatMap(function (bar) {
      return bar.circles;
    });
    var barLines = barChordsText.filter(function (bar) {
      return !!bar.lines;
    }).flatMap(function (bar) {
      return bar.lines;
    });
    var startXList = barChordsText.map(function (bar) {
      return bar.startXList;
    });
    barChordsText = barChordsText.flatMap(function (bar) {
      return bar.chordTexts;
    });
    var returnObj = {
      texts: barChordsText,
      startX: startXList
    };
    if (barLines) returnObj.paths = barLines;
    if (barCircles) returnObj.circles = barCircles;
    return returnObj;
  };
  return {
    getChordSvgElems: getChordSvgElems,
    getSvgElems: getSvgElems
  };
};
var _default = exports["default"] = ChordTexts;