"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var heightMargin = 100;
var useAutoScroll = function useAutoScroll(bars, activeBar, ref) {
  var lastRefY = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var _ref$current, _bars$activeBar;
    var wrappingDiv = ref === null || ref === void 0 || (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.getBoundingClientRect();
    var currentBarDims = (_bars$activeBar = bars[activeBar]) === null || _bars$activeBar === void 0 ? void 0 : _bars$activeBar.dimensions;
    if (!wrappingDiv || !currentBarDims) {
      return;
    }
    var barTop = currentBarDims.y + wrappingDiv.top;
    var heightLimit = (wrappingDiv === null || wrappingDiv === void 0 ? void 0 : wrappingDiv.height) + wrappingDiv.top - heightMargin;
    var lastBarY = lastRefY.current;
    var currentBarY = currentBarDims.y;
    var isNewLoop = currentBarY < lastBarY;
    var isLineChange = currentBarY !== lastBarY;
    if (isNewLoop || activeBar === 0) {
      ref.current.scrollTo({
        top: 0
      });
    } else if (barTop > heightLimit && isLineChange) {
      ref.current.scrollBy({
        top: 100,
        behavior: "smooth"
      });
    }
    lastRefY.current = currentBarDims.y;
  }, [activeBar, bars]);
  return ref;
};
var _default = exports["default"] = useAutoScroll;